package com.ruoyi.report.controller;

import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import javax.servlet.http.HttpServletResponse;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.ruoyi.common.annotation.Log;
import com.ruoyi.common.constant.ApplicantType;
import com.ruoyi.common.constant.PatentType;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.enums.BusinessType;
import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.report.domain.HeadColumn;
import com.ruoyi.report.domain.RzlClassStatisticsInfo;
import com.ruoyi.report.service.IRzlClassStatisticsInfoExcel;
import com.ruoyi.report.service.IRzlClassStatisticsInfoService;
import com.ruoyi.report.vo.ClassStatisticsInfoVo;

/**
 * 专利有效-分类统计Controller
 *
 * @author ruoyi
 * @date 2023-03-26
 */
@RestController
@RequestMapping("/report/rzlClassStatisticsInfo")
public class RzlClassStatisticsInfoController extends BaseController {
	private final IRzlClassStatisticsInfoService rzlClassStatisticsInfoService;

	public RzlClassStatisticsInfoController(IRzlClassStatisticsInfoService rzlClassStatisticsInfoService) {
		this.rzlClassStatisticsInfoService = rzlClassStatisticsInfoService;
	}

	@Autowired
	private IRzlClassStatisticsInfoExcel rzlClassStatisticsInfoExcel;

	private int getPatentTypeCount(String patentTypes) {
		Set<String> ids = new HashSet<String>();
		List<HeadColumn> columnList = new ArrayList<HeadColumn>();
		String[] patentTypeArr = patentTypes.split(",");
		if (patentTypeArr.length > 1) {
			for (int i = 0; i < patentTypeArr.length; i++) {
				PatentType at = PatentType.valueOf(patentTypeArr[i]);
				if (at != null) {
					HeadColumn column = new HeadColumn();
					column.setName(at.getTypeName());
					columnList.add(column);
					ids.add(at.getTypeId());
				}
			}
		}
		return ids.size();
	}

	@GetMapping("/getHeader")
	public AjaxResult getHeader(String patentTypes, String applicantTypes) {
		if (StringUtils.isBlank(patentTypes)) {
			patentTypes = PatentType.getAllPatentTypeIdStr();
		}
		if (StringUtils.isBlank(applicantTypes)) {
			applicantTypes = ApplicantType.getAllApplicantTypeIdStr();
		}
		List<HeadColumn> columnList = new ArrayList<HeadColumn>();
		if (getPatentTypeCount(patentTypes) >= 1) {
			HeadColumn column1 = new HeadColumn();
			column1.setName("专利类型");
			columnList.add(column1);
		}
		String[] applicantTypeArr = applicantTypes.split(",");

		if (applicantTypeArr.length > 1) {
			HeadColumn column1 = new HeadColumn();
			column1.setName("合计");
			columnList.add(column1);
		}
		for (int i = 0; i < applicantTypeArr.length; i++) {
			ApplicantType at = ApplicantType.valueOf(applicantTypeArr[i]);
			if (at != null) {
				HeadColumn column = new HeadColumn();
				column.setName(at.getTypeName());
				columnList.add(column);
			}
		}

		return AjaxResult.success(columnList);

	}

	@GetMapping("/getHeight")
	public AjaxResult getHeight(String patentTypes) {
		if (StringUtils.isBlank(patentTypes)) {
			patentTypes = PatentType.getAllPatentTypeIdStr();
		}
		List<HeadColumn> columnList = new ArrayList<HeadColumn>();
		String[] patentTypesArr = patentTypes.split(",");
		if (patentTypesArr.length > 1) {
			HeadColumn column1 = new HeadColumn();
			column1.setName("合计");
			columnList.add(column1);
		}
		for (int i = 0; i < patentTypesArr.length; i++) {
			PatentType at = PatentType.valueOf(patentTypesArr[i]);
			if (at != null) {
				HeadColumn column = new HeadColumn();
				column.setName(at.getTypeName());
				columnList.add(column);
			}
		}
		return AjaxResult.success(columnList);

	}

	/**
	 * 查询专利有效-分类统计列表
	 *
	 * @param rzlClassStatisticsInfo 专利有效-分类统计
	 * @return 专利有效-分类统计集合
	 * @date 2023-03-26
	 */
//	@PreAuthorize("@ss.hasPermi('report:rzlClassStatisticsInfo:list')")
//	@GetMapping("/list_bak")
//	public TableDataInfo list(RzlClassStatisticsInfo rzlClassStatisticsInfo) {
//		startPage();
//		List<RzlClassStatisticsInfo> list = rzlClassStatisticsInfoService.queryList(rzlClassStatisticsInfo);
//		return getDataTable(list);
//	}

	/**
	 * 查询专利有效-分类统计列表
	 * 
	 * @param rzlClassStatisticsInfo 专利有效-分类统计
	 * @return
	 */
	@PreAuthorize("@ss.hasPermi('report:rzlViewStatisticsInfo:list')")
	@GetMapping("/list")
	public TableDataInfo list(RzlClassStatisticsInfo rzlClassStatisticsInfo) {

		if (rzlClassStatisticsInfo != null) {
			if (StringUtils.isNotBlank(rzlClassStatisticsInfo.getPatentTypes())) {
				List<String> patentTypesList = new ArrayList<String>();
				String[] patentTypes = rzlClassStatisticsInfo.getPatentTypes().split(",");
				for (String pt : patentTypes) {
					if (StringUtils.isNotBlank(pt)) {
						PatentType patentType = PatentType.valueOf(pt.trim());
						if (patentType != null) {
							patentTypesList.add(patentType.getTypeName());
						}
					}
				}
				rzlClassStatisticsInfo.setPatentTypesList(patentTypesList);
			}

			if (StringUtils.isNotBlank(rzlClassStatisticsInfo.getApplicantTypes())) {
				List<String> patentTypesList = new ArrayList<String>();
				String[] patentTypes = rzlClassStatisticsInfo.getApplicantTypes().split(",");
				for (String pt : patentTypes) {
					if (StringUtils.isNotBlank(pt)) {
						ApplicantType at = ApplicantType.valueOf(pt);
						if (at != null) {
							patentTypesList.add(at.getTypeName());
						}

					}
				}
				rzlClassStatisticsInfo.setApplicantTypesList(patentTypesList);
			}
		}

//	        List<RzlViewStatisticsInfo> list = rzlViewStatisticsInfoService.queryList(rzlViewStatisticsInfo);
		List<ClassStatisticsInfoVo> voList = rzlClassStatisticsInfoService.listByReport(rzlClassStatisticsInfo);

//	        try {
//				OutputStream out=new FileOutputStream(new File("D:\\temp\\exp.xlsx"));
//				
//				rzlClassStatisticsInfoExcel.doExport(out,rzlClassStatisticsInfo,voList);
//				
//				
//			} catch (Exception e) {
//				// TODO Auto-generated catch block
//				e.printStackTrace();
//			}

		return getDataTable(voList);
	}

	/**
	 * 导出专利有效-分类统计列表
	 *
	 * @param rzlClassStatisticsInfo 专利有效-分类统计
	 * @date 2023-03-26
	 */
	@PreAuthorize("@ss.hasPermi('report:rzlClassStatisticsInfo:export')")
	@Log(title = "专利有效-分类统计", businessType = BusinessType.EXPORT)
	@PostMapping("/export")
	public void export(HttpServletResponse response, RzlClassStatisticsInfo rzlClassStatisticsInfo) {

		if (rzlClassStatisticsInfo != null) {
			if (StringUtils.isNotBlank(rzlClassStatisticsInfo.getPatentTypes())) {
				List<String> patentTypesList = new ArrayList<String>();
				String[] patentTypes = rzlClassStatisticsInfo.getPatentTypes().split(",");
				for (String pt : patentTypes) {
					if (StringUtils.isNotBlank(pt)) {
						PatentType patentType = PatentType.valueOf(pt.trim());
						if (patentType != null) {
							patentTypesList.add(patentType.getTypeName());
						}
					}
				}
				rzlClassStatisticsInfo.setPatentTypesList(patentTypesList);
			}

			if (StringUtils.isNotBlank(rzlClassStatisticsInfo.getApplicantTypes())) {
				List<String> patentTypesList = new ArrayList<String>();
				String[] patentTypes = rzlClassStatisticsInfo.getApplicantTypes().split(",");
				for (String pt : patentTypes) {
					if (StringUtils.isNotBlank(pt)) {
						ApplicantType at = ApplicantType.valueOf(pt);
						if (at != null) {
							patentTypesList.add(at.getTypeName());
						}

					}
				}
				rzlClassStatisticsInfo.setApplicantTypesList(patentTypesList);
			}
		}

//	        List<RzlViewStatisticsInfo> list = rzlViewStatisticsInfoService.queryList(rzlViewStatisticsInfo);
		List<ClassStatisticsInfoVo> voList = rzlClassStatisticsInfoService.listByReport(rzlClassStatisticsInfo);

		try {

			response.setContentType("application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
			response.setCharacterEncoding("utf-8");
			rzlClassStatisticsInfoExcel.doExport(response.getOutputStream(), rzlClassStatisticsInfo, voList);

		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			logger.error("导出失败,"+e.getMessage(),e);
			throw new RuntimeException("导出失败，请联系管理员",e);
		}

	}

	/**
	 * 获取专利有效-分类统计详细信息
	 *
	 * @param id 主键id
	 * @return 结果
	 * @date 2023-03-26
	 */
	@PreAuthorize("@ss.hasPermi('report:rzlClassStatisticsInfo:query')")
	@GetMapping(value = "/{id}")
	public AjaxResult getInfo(@PathVariable("id") Long id) {
		return AjaxResult.success(rzlClassStatisticsInfoService.getById(id));
	}

	/**
	 * 新增专利有效-分类统计信息
	 *
	 * @param rzlClassStatisticsInfo 专利有效-分类统计
	 * @return 结果
	 * @date 2023-03-26
	 */
	@PreAuthorize("@ss.hasPermi('report:rzlClassStatisticsInfo:add')")
	@Log(title = "专利有效-分类统计", businessType = BusinessType.INSERT)
	@PostMapping
	public AjaxResult add(@RequestBody RzlClassStatisticsInfo rzlClassStatisticsInfo) {
		return toAjax(rzlClassStatisticsInfoService.save(rzlClassStatisticsInfo));
	}

	/**
	 * 修改专利有效-分类统计信息
	 *
	 * @param rzlClassStatisticsInfo 专利有效-分类统计
	 * @return 结果
	 * @date 2023-03-26
	 */
	@PreAuthorize("@ss.hasPermi('report:rzlClassStatisticsInfo:edit')")
	@Log(title = "专利有效-分类统计", businessType = BusinessType.UPDATE)
	@PutMapping
	public AjaxResult edit(@RequestBody RzlClassStatisticsInfo rzlClassStatisticsInfo) {
		return toAjax(rzlClassStatisticsInfoService.updateById(rzlClassStatisticsInfo));
	}

	/**
	 * 删除专利有效-分类统计信息
	 *
	 * @param ids 主键ids
	 * @return 结果
	 * @date 2023-03-26
	 */
	@PreAuthorize("@ss.hasPermi('report:rzlClassStatisticsInfo:remove')")
	@Log(title = "专利有效-分类统计", businessType = BusinessType.DELETE)
	@DeleteMapping("/{ids}")
	public AjaxResult remove(@PathVariable Long[] ids) {
		return toAjax(rzlClassStatisticsInfoService.removeByIds(Arrays.asList(ids)));
	}

}
